/*
 * Copyright (c) 2023 - 2024. KeyWare.Co.Ltd All rights reserved.
 * 项目名称：C++ 信息安全性设计准则
 * 项目描述：用于检查C++源代码的安全性设计准则的Sonarqube插件
 * 版权说明：本软件属北京关键科技股份有限公司所有，在未获得北京关键科技股份有限公司正式授权情况下，任何企业和个人，不能获取、阅读、安装、传播本软件涉及的任何受知识产权保护的内容。
 */
package com.keyware.sonar.cxx.rules.checkers;

import com.keyware.sonar.cxx.CxxFileTesterHelper;
import org.junit.jupiter.api.Test;
import org.sonar.cxx.CxxAstScanner;
import org.sonar.cxx.squidbridge.api.SourceFile;
import org.sonar.cxx.squidbridge.checks.CheckMessagesVerifier;

import java.io.IOException;

/**
 * TODO DLLVerifyCheckerTest
 *
 * @author RenFengJiang
 * @date 2024/1/19
 */
public class DLLVerifyCheckerTest {
    @Test
    public void checkTest() throws IOException {
        var checker = new DLLVerifyChecker();
        var tester = CxxFileTesterHelper.create("DLLVerifyChecker.cc");
        SourceFile file = CxxAstScanner.scanSingleInputFile(tester.asInputFile(), checker);
        CheckMessagesVerifier.verify(file.getCheckMessages())
                .next().atLine(17).withMessage("在动态加载库前对输入数据进行验证")
                .next().atLine(43).withMessage("在动态加载库前对输入数据进行验证")
                .noMore();
    }
}
