/*
 * Copyright (c) 2023 - 2024. KeyWare.Co.Ltd All rights reserved.
 * 项目名称：信息安全性设计准则检查插件
 * 项目描述：用于检查源代码的安全性设计准则的Sonarqube插件
 * 版权说明：本软件属北京关键科技股份有限公司所有，在未获得北京关键科技股份有限公司正式授权情况下，任何企业和个人，不能获取、阅读、安装、传播本软件涉及的任何受知识产权保护的内容。
 */

package com.keyware.sonar.java.utils;

import org.junit.jupiter.api.extension.AfterEachCallback;
import org.junit.jupiter.api.extension.ExtensionContext;
import org.sonar.plugins.html.checks.HtmlIssue;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Html规则校验
 *
 * @author GuoXin
 * @date 2024/1/20
 */
public class HtmlCheckMessagesVerifierRule implements AfterEachCallback {
    private final List<HtmlCheckMessagesVerifier> verifiers = new ArrayList<>();

    public HtmlCheckMessagesVerifier verify(Collection<HtmlIssue> messages) {
        HtmlCheckMessagesVerifier verifier = HtmlCheckMessagesVerifier.verify(messages);
        verifiers.add(verifier);
        return verifier;
    }

    protected void verify() {
        for (HtmlCheckMessagesVerifier verifier : verifiers) {
            verifier.noMore();
        }
    }

    @Override
    public void afterEach(ExtensionContext extensionContext) throws Exception {
        verify();
    }
}
